#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <unistd.h>
#include <malloc.h>
#include <errno.h>
#include "client.h"
#include "extract.h"
#include "audioplay.h"
#include "networkio.h"

#include "vodSGI.h"
#include "sc.h"
#include "sysplayer.h"

#define SERVER "sandman.npac.syr.edu"

static void Abandon(char *s);
static void initialize(char *filename);

MpegPlay *play;  /* in sysplayer.h */

void main(int argc, char *argv[])
{
  header info;
  url_info **urls;
  int numUrls;

  /* check input parameters */
  /* if (!parse(argc, argv))
     showValidArgs();
     */

  /* initialize data structures */
  initialize(argv[1]); /* the audio file to be played */

  /* initialize network setup, connect to server and give the load
     'movie' (audio) command */
  setupConnection();

  /* read from network here once to get header and urls if any */
  numUrls = extract_fileinfo(play -> dataSocket,&info,urls);
  printf("main: numUrls = %d\n", numUrls);
  if (numUrls) {
    urls = allocate(numUrls, urls);
    printf("main:memory allocated for urls\n");
    extract_url(play -> dataSocket, urls, numUrls);
    printf("url[0]: %s\n", urls[0]->url);
    printf("offset[0]: %ld\n", urls[0]->offset);
    printf("main:o.k after printing url info\n");
  }
  
  /* read from network, decode and play, and display pages */
  Play(play->dataSocket, urls, numUrls, &info);

  /* terminate connection - normal */
  sendCommand(VODTerminateConnection);
  fprintf(stdout, "Terminating connection ...\n");
  close(play -> dataSocket);
  close(play -> commandSocket);

}

static void Abandon(char *s)
{
  fprintf(stderr, "Fatal error:client: %s\n", s);
  exit(1);
}

static void initialize(char *filename)
{
  int length;

  play = (MpegPlay *) malloc(sizeof(MpegPlay));
  if (!play)
    Abandon("client:initialize:Memory allocation failure");

  length = strlen(filename);
  play -> filename = (char*) malloc((length+1) * sizeof(char));
  if (!play -> filename)
    Abandon("client:initialize: memory allocation failure");
  strcpy(play -> filename, filename);
  printf("audio file = %s , length = %d\n",play -> filename, length); 
  
  play -> fileOffset = 0L;

  /* initialize server IP, etc. */
  play -> serverIP = (char *) malloc ((strlen(SERVER)+1) *
				      sizeof(char) );
  if (!play -> serverIP)
    Abandon("client:initialize: memory allocation failure");
  strcpy(play -> serverIP, SERVER);

  play -> serverFilename = (char *) malloc ((length+1) * sizeof(char));
  if (!play -> serverFilename)
    Abandon("client:initialize: memory allocation failure");
  strcpy(play -> serverFilename, filename);

  play -> serverFileOffset = play -> fileOffset;
}
